RSpec::Support.require_rspec_core "formatters/json_formatter"

module NoradSpecRunner

  class CustomJsonFormatter < RSpec::Core::Formatters::JsonFormatter
    RSpec::Core::Formatters.register self, :message, :dump_summary, :dump_profile, :stop, :close

    def stop(notification)
      @output_hash[:examples] = notification.examples.map do |example|
         format_example(example).tap do |hash|
           # Add custom fields to output json hash.
           hash[:norad_nid] = example.norad_nid
           hash[:norad_description] = example.norad_description
           hash[:norad_output] = example.norad_output
           if (ex=example.exception)
             hash[:exception] =  {
               :class => ex.class.name,
               :message => ex.message,
               :backtrace => ex.backtrace,
             }
           end
         end
      end
    end
  end

end
