module NoradSpecRunner
  class SecTest
    UNSUPPORTED_SPEC_FILE = "#{File.expand_path(File.dirname(__FILE__))}/support/os_not_supported_spec.rb"
    attr_reader :tests_parent_dir, :test_name, :platform

    def initialize(tests_parent_dir, test_name, platform)
      @tests_parent_dir = tests_parent_dir
      @test_name = test_name
      @platform = platform
      print_detection_message
    end

    def test_to_run
      suggested_test_file_exists? ? suggested_test_file : default_test_file
    end

    def suggested_test_file_exists?
      File.exist?("#{tests_parent_dir}/#{suggested_test_file}")
    end

    def suggested_test_file
      "#{test_name}/#{platform}_spec.rb"
    end

    def default_test_file
      UNSUPPORTED_SPEC_FILE
    end

    private

    def print_detection_message
      platform ? puts("Platform #{platform} detected!") : puts("Unable to detect OS!")
    end
  end
end
